; This program is free software. It comes without any warranty, to
; the extent permitted by applicable law. You can redistribute it
; and/or modify it under the terms of the Do What The Fuck You Want
; To Public License, Version 2, as published by Sam Hocevar. See
; http://sam.zoy.org/wtfpl/COPYING for more details.

; LPS = Length Prefixed String
; ZTS = Zero Terminated String
#ifdef blah
; instrFlags ; These flags are used by the disassembler
insertStrSub	.equ	7	; in editorFlags
Used exclusively by InsertString

noBcall		.equ	6
Used exclusively by checkDoBcall

isNeg		.equ	5
Used exclusively by insertImmArg

prefixCB	.equ	4
Used exclusively in the prefix parsers

prefixED	.equ	3
Used exclusively in the prefix parsers

subHLInd	.equ	2
Used in doIndexMadness and to see if a second pass is needed in ProcessInstructionString.
InstrBy
prefixIndex	.equ	1
copyAndProcessString, second pass, insertArg, and the prefix parser

prefixIY	.equ	0	; Do not change
#endif

;====== Disassembler User Interface ============================================
disasmCase:
	ld	a, (iy+editorFlags)
	xor	disasmLowerCaseMask
	ld	(iy+editorFlags), a
	jr	Disassembler

disasmBcalls:
	ld	a, (iy+instrFlags)
	xor	noBcallMask
	ld	(iy+instrFlags), a
;	jr	Disassembler

; 0123456789 123456789 123456789 1
; ABCD: 11223344 set a,3,(ix+44)
Disassembler:
	ld	a, (mflags + editorFlags)
	or	retDisasmMask
	ld	(mflags + editorFlags), a
	call	SetFullScrnWind
	call	HomeUp
;	call	ClearWind
	ld	ix, (editLocation)
	ld	iy, mflags
	ld	a, 15
	ld	(tabPos2), a
disasmDrawLoop:
	push	ix
	pop	hl
	ld	bc, (editOffset)
	add	hl, bc
	call	DispHL
	ld	a, ':'
	call	PutC
	call	PutSpace
	ld	(disasmPtr), ix
	call	DisassembleInstruction
_:	ld	a, (ix)
	call	DispByte
	inc	ix
	ld	hl, (disasmPtr)
	ld	a, ixl
	cp	l
	jr	nz, -_
	ld	a, ixh
	cp	h
	jr	nz, -_
	call	NextTab
	ld	hl, instrTextBufText
	call	PutS
	call	NewLineClrEOL2
	ld	a, (currentRow)
	cp	textRows-1
	jr	nz, disasmDrawLoop
	call	editShowMemMap
	call	editShowIndics
	call	NewLineClrEOL
	; Don't show effective location because there isn't a cursor.
disasmLoop:
	call	GetKey
	ld	hl, disasmKeyTable
	call	ProcessKeyJumpTable
	jr	disasmLoop
	
disasmNext:
	ld	hl, (editLocation)
	ld	(disasmPtr), hl
	call	DisassembleInstruction
	ld	hl, (disasmPtr)
	ld	(editLocation), hl
	jp	Disassembler
disasmPrev:
	ld	hl, (editLocation)
	dec	hl
	ld	(editLocation), hl
	jp	Disassembler
disasmPrevPage:
	ld	hl, (editLocation)
	ld	de, -12
	add	hl, de
	ld	(editLocation), hl
	jp	Disassembler
disasmPage:
	ld	hl, (editLocation)
	ld	(disasmPtr), hl
	ld	b, 8
_:	push	bc
	call	DisassembleInstruction
	pop	bc
	djnz	-_
	ld	hl, (disasmPtr)
	ld	(editLocation), hl
	jp	Disassembler


;====== Main Disassembler Routine ==============================================
DisassembleInstruction:
; Output:
;  - (instrTextBufText): Contains the string of the disassembled instruction
	; Reset things
	ld	hl, instrTextBuf
	ld	b, instrTextBufLen+argBufLen+6
	xor	a
	call	clearMem
	ld	a, (iy+instrFlags)
	and	0C0h
	ld	(iy+instrFlags), a
	ld	hl, primaryDecodingTable
disasmDecodeLoop: ; Parse decoding table
	call	getInstrByte
	ld	(instrCode), a
	ld	b, (hl)
	bit	7, b
	jr	nz, decodeNothingForString
	inc	hl
	bit	6, b
	jr	nz, decodeAndGetString
	bit	5, b
	jr	nz, decodeAndJump
	jp	mainMenu
decodeInstrAndIndex:
	ld	a, (instrCode)
	ld	c, a
	ld	a, b
	call	getField
	add	a, l
	ld	l, a
	ret	nc
	inc	h
	ret
decodeAndJump:
	call	decodeInstrAndIndex
	ld	a, (hl)
	add	a, l
	ld	l, a
	jr	nc, disasmDecodeLoop;+_
	inc	h
;_:	jr	disasmDecodeLoop
	jr	disasmDecodeLoop
decodeAndGetString:
	call	decodeInstrAndIndex
decodeNothingForString:
	ld	a, (hl)
copyAndProcessString:
	and	7Fh
	push	af
;	xor	a
	ld	a, 23h
	ld	b, instrTextBufLen
	ld	hl, instrTextBuf
	call	ClearMem
	pop	af
	ld	hl, instrNameTbl
	call	getStrIndexed
	ld	a, (hl)
;	and	0C0h
;	jr	z, ++_
	bit	6, a ; Disable IX/IY prefix?
	jr	nz, +_
	res	prefixIndex, (iy+instrFlags)
_:	bit	7, a ; Jump to code?
	jr	z, +_
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ex	de, hl
	jp	(hl)
_:	ld	de, instrTextBuf
	call	CopyLPS
ProcessInstructionString:
; Pass 1
; Do everything EXCEPT convert HL to IX, H to IXH, and L to IXL.
	ld	hl, instrTextBuf
	ld	b, (hl)
pislp:	inc	hl
	ld	a, (hl)
	cp	lastSub
	jp	c, insertSub
	bit	7, a
	jp	nz, insertArg
	cp	41h
	jr	c, +_
	cp	5Bh
	jr	nc, +_
	bit	disasmLowerCase, (iy+editorFlags)
	jr	z, +_
	add	a, 20h	
	ld	(hl), a
_:	djnz	pislp
; Pass 2
	; check if pass is needed
	bit	prefixIndex, (iy+instrFlags)
	jr	z, noSecondPass
	bit	subHLInd, (iy+instrFlags)
	jr	nz, noSecondPass
	; find first space
p2:	ld	hl, instrTextBuf
	ld	b, (hl)
	ld	a, 32
_:	inc	hl
	cp	(hl)
	jr	z, p2loop
	djnz	-_
	; No space = no arguments = no registers to change
	; But no-argument instructions shouldn't accept index prefixen anyway.
	jr	noSecondPass
; TO DO: Prevent infinite insertion of IX/IY before IX/Y H/L ; Fixed?
p2loop:	inc	hl
	ld	a, (hl)
	and	11011111b
	cp	48h	; H
	jr	z, p2h
	and	11011111b
	cp	4Ch	; L
	jr	z, p2l
p2lq:	djnz	p2loop
	jr	noSecondPass
p2l:	; Just index half-registers
	push	hl
	push	bc
	ld	c, l
	ld	b, h
	ld	de, instrTextBuf
	ld	hl, indexX
	call	InsertString
	pop	bc
	pop	hl
	; Inserted two bytes, and then inc over them, so no change for b
	call	checkForceLwr
	inc	hl
	bit	prefixIY, (iy+instrFlags)
	jr	z, +_
	inc	(hl)
_:	call	checkForceLwr
	inc	hl
	djnz	p2lq
	jr	noSecondPass
p2h:	; Maybe just convert HL to IX/IY?
	inc	hl
	ld	a, (hl)
	dec	hl
	and	11011111b
	cp	4Ch	; L
	jr	nz, p2l
	ld	(hl), 49h	; I
	call	checkForceLwr
	inc	hl
	ld	(hl), 58h	; X
	call	checkForceLwr
	bit	prefixIY, (iy+instrFlags)
	jr	z, +_
	inc	(hl)
_:	; Inc'ed over one byte, so dec b to match
	dec	b
	djnz	p2loop
noSecondPass:
	call	getNextInstrByte
	ld	hl, instrTextBuf
	call	ZeroTermString
	ret		; End of routine
checkForceLwr:
	bit	disasmLowerCase, (iy+editorFlags)
	ret	z
	ld	a, (hl)
	cp	41h
	ret	c
	cp	5Bh
	ret	nc
;	and	11011111b
	add	a, 20h
	ld	(hl), a
	ret


insertSub:
	ld	c, l
	ld	b, h
	dec	a
	ld	hl, subTbl
	call	getStrIndexed
	ld	de, instrTextBuf
	call	InsertString
;	jr	ProcessInstructionString
	jp	ProcessInstructionString

insertArg:
;	ld	(instrProcAddr), hl	; Stuff that address into a temp for later
; There's gotta be a cleaner way to do this!
	bit	isArgImm, a
	jr	nz, insertImmArg
	ld	a, (instrCode)
	ld	c, a
	ld	a, (hl)
;	and	3Fh
	call	getField
; To do: If the table is the Reg8 table and the argument is (HL), check
; for indexing madness
; Update: Done!  (I hope.)
	; Got the field we needed from the instruction.  Now select the table.
	ld	b, a
	ld	a, (hl)
	srl	a
	srl	a
	srl	a
	and	7
	cp	7		; Is Reg8 table?
	ld	c, a
	ld	a, b
	jr	nz, +_
	bit	prefixIndex, (iy+instrFlags)
	jr	z, +_
	cp	6		; Is this (HL)?
	jr	z, doIndexMadness
_:	ld	b, 0
	push	hl
	ld	hl, argMetaTable
	sla	c		; Multiply by two for table index
	add	hl, bc
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ex	de, hl
	call	getStrIndexed
	ld	de, instrTextBuf
	pop	bc
	; Now insert the text into the string
	call	InsertString
	jp	ProcessInstructionString
doIndexMadness:
	push	hl
	pop	bc
	set	subHLInd, (iy+instrFlags);set	subHLInd, (ix+instrFlags)
	ld	hl, indexArg
;	bit	prefixIY, (iy+instrFlags)
;	jr	z, +_
;	ld	hl, indeyArg
_:	ld	de, instrTextBuf
	call	InsertString
	jp	ProcessInstructionString

insertImmArg:
; This may need to be reworked?
	res	isNeg, (iy+instrFlags)
	ld	c, a
	ld	a, (instrOffset)	; Maybe cached?
	bit	isArgCached, c
	jr	nz, +_
	call	getNextInstrByte	; Nope.
_:	bit	isArgRelAddr, c		; Is djnz/jr?
	jr	nz, insertRelAddress
	bit	isArg16, c		; Is two-byte arg?
	jr	z, +_
	call	insertByte
	call	getNextInstrByte
_:	bit	isArgSigned, c		; Indexen
	jr	z, ++_
	; We're doing an index offset!  While we're here, convert IX to IY if needed.
;	ld	hl, (instrProcAddr)
	bit	prefixIY, (iy+instrFlags)
	jr	z, +_
	dec	hl
;	dec	hl
	inc	(hl)
	inc	hl			; No pun intended.
;	inc	hl
_:	bit	7, a
	jr	z, +_
	set	isNeg, (iy+instrFlags)
	neg
_:	call	insertByte
	bit	isArgSigned, c
	jp	z, ProcessInstructionString
	ld	de, argBuf
	ld	a, 1
	ld	(de), a
	inc	de
	ld	a, 2Bh
	bit	isNeg, (iy+instrFlags)
	jr	z, +_
	inc	a
	inc	a
_:	ld	(de), a
	dec	de
	ex	de, hl
	ld	c, e
	ld	b, d
	ld	de, instrTextBuf
	call	InsertString
	jp	ProcessInstructionString
insertRelAddress:
	ex	de, hl
	ld	hl, (disasmPtr)
	inc	hl
	ld	b, 0
	ld	c, a
	bit	7, a
	jr	z, +_
	dec	b
_:	add	hl, bc
	ld	bc, (editOffset)
	add	hl, bc
	ex	de, hl
	ld	a, e
	call	insertByte
	ld	a, d
	call	insertByte
	jp	ProcessInstructionString



;====== Stubs ==================================================================
; Several parts of the disassembly tables need to check for a special condition
; or do something special before proceeding.  These are those stubs.
checkHalt:
	ld	a, (instrCode)
	cp	76h ; HALT
	ld	a, instrLdRRReal
	jp	nz, copyAndProcessString
	inc	a
	jp	copyAndProcessString
checkDoBcall:
	bit	noBcall, (iy+instrFlags)
	ld	a, instrBcall
	jp	z, copyAndProcessString
	ld	a, instrRst28hReal
	jp	copyAndProcessString
checkIn:
	ld	a, (instrCode)
	cp	70h ; second byte of IN F, (C)
	ld	a, instrInCReal
	jp	nz, copyAndProcessString
	inc	a
	jp	copyAndProcessString
checkOut:
	ld	a, (instrCode)
	cp	71h ; second byte of OUT (C), 0
	ld	a, instrOutCReal
	jp	nz, copyAndProcessString
	inc	a
	jp	copyAndProcessString
checkForNoIndexPrefixes:
	bit	prefixIndex, (iy+instrFlags)
	jr	nz, invalidPrefixSequence
checkForNoPrefixes:
	bit	prefixCB, (iy+instrFlags)
	jr	nz, invalidPrefixSequence
	bit	prefixED, (iy+instrFlags)
	jr	nz, invalidPrefixSequence
	ret
processPrefixCB:
	call	checkForNoPrefixes
	set	prefixCB, (iy+instrFlags)
	ld	hl, cbDecodingTable
	bit	prefixIndex, (iy+instrFlags)
	jr	z, +_
	call	getNextInstrByte
	ld	(instrOffset), a
	ld	hl, cbAutocopyDecodingTable
_:	call	getNextInstrByte
	jp	disasmDecodeLoop
processPrefixED:
	call	checkForNoIndexPrefixes
	set	prefixED, (iy+instrFlags)
	ld	hl, edDecodingTable
	call	getNextInstrByte
	jp	disasmDecodeLoop
processPrefixDD:
	call	checkForNoIndexPrefixes
	set	prefixIndex, (iy+instrFlags)
	res	prefixIY, (iy+instrFlags)
	ld	hl, primaryDecodingTable
	call	getNextInstrByte
	jp	disasmDecodeLoop
processPrefixFD:
	call	checkForNoIndexPrefixes
	set	prefixIndex, (iy+instrFlags)
	set	prefixIY, (iy+instrFlags)
	ld	hl, primaryDecodingTable
	call	getNextInstrByte
	jp	disasmDecodeLoop
invalidPrefixSequence:
	pop	af
	ld	a, instrInvalid
	jp	copyAndProcessString


;====== Routines ===============================================================
getInstrByteRaw:
	ld	hl, (disasmPtr)
;	ld	a, (disasmPtrPage)
;	ld	b, a
;	call	ReadByte
	ld	a, (hl)
	ret
getInstrByte:
	push	bc
	push	hl
	call	getInstrByteRaw
	pop	hl
	pop	bc
	ret
getNextInstrByte:
	push	bc
	push	hl
	call	getInstrByteRaw
	call	IncReadPtr
	call	saveInstrPtr
	call	getInstrByteRaw
	pop	hl
	pop	bc
	ret
IncReadPtr:
	inc	hl
	ret
saveInstrPtr:
	ld	(disasmPtr), hl
;	ld	a, b
;	ld	(disasmPtrPage), a
	ret

getField:
; Inputs:
;  - A: Field
;  - C: Byte to extract field from
; Output:
;  - A: The specified field is read from C
	push	bc
	push	hl
	ld	hl, argDescTable
	and	7
	add	a, l
	jr	nc, +_
	inc	h
_:	ld	l, a
	ld	b, (hl)	; Not going to bother with masking here.
;	inc	hl
_:	rrc	c
	djnz	-_
	ld	a, (hl)
	srl	a
	srl	a
	srl	a
	and	c
;	and	7
	pop	hl
	pop	bc
	ret

;DispLPS:
; Displays a string
; Inputs:
;  - HL: Pointer to length byte of string
;	push	bc
;	ld	b, (hl)
;_:	inc	hl
;	ld	a, (currentRow)
;	cp	8
;	jr	nc, +_
;	ld	a, (hl)
;	call	PutC
;	djnz	-_
;_:	pop	bc
;	ret

getStrIndexed:
; Given an index into a table of LPSs, this finds the specified string
; Inputs:
;  - A: Index
;  - HL: Pointer to table
; Output:
;  - HL: Pointer to selected string
	or	a
	ret	z
	push	bc
	ld	b, a
gsil:	ld	a, (hl)
	and	3Fh
	add	a, l
	ld	l, a
	jr	nc, +_
	inc	h
_:	inc	hl
	djnz	gsil
	pop	bc
	ret

;GetStrLength:
; Returns the length of a ZTS
; Inputs:
;  - HL: Pointer to string
; Output:
;  - B: Length
;	xor	a
;	ld	b, a
;_:	cp	(hl)
;	ret	z
;	inc	b
;	jr	-_

ZeroTermString:
; Converts an LPS into a ZTS
; Inputs:
;  - HL: Pointer to length byte of LPS
; Destroys: AF
	push	hl
	ld	a, (hl)
	inc	hl
	add	a, l
	jr	nc, +_
	inc	h
_:	ld	l, a
	ld	(hl), 0
	pop	hl
	ret

CopyLPS:
; Copies an LPS from HL to DE that is no longer than 31 bytes
	ld	a, (hl)
	and	1Fh
	ld	(de), a
	inc	de
	inc	hl
	ld	c, a
	ld	b, 0
	ldir
	ret	

InsertString:
; Yeah, I couldn't come up with a better way to do this :/
; Inputs:
;  - HL: Pointer to string to read from, length prefixed; that is, the actual length byte
;  - DE: Pointer to string to insert into, length prefixed
;  - BC: Location to insert into
; Output:
;  - String inserted
; Destroys:
;  - AF BC DE HL
	push	ix
	res	insertStrSub, (iy+editorFlags)
	ld	a, (bc)
	bit	7, a
	jr	nz, +_
	cp	32
	jr	nc, instra
_:	set	insertStrSub, (iy+editorFlags)
instra:	; I give up.  Let's allocate some RAM on the stack.
	ld	ix, 0
	add	ix, sp
	push	bc ; ix-1,2
	push	de ; ix-3,4
	push	hl ; ix-5,6
	ld	a, (de)
	push	af ; ix-7,8 A=(ix-7)  (ix-7)=orig len, (ix-8)=new len
	add	a, (hl)
	bit	insertStrSub, (iy+editorFlags)
	jr	z, +_
	dec	a
_:	ld	(de), a
	ld	(ix-8), a
	push	de
	; de will be ptr to old end of string
	ld	a, (ix-7)
	add	a, e
	jr	nc, +_
	inc	d
_:	ld	e, a
	; bc will be the number of bytes after the insertion point
	ld	l, e
	ld	h, d
	or	a
	sbc	hl, bc
	ld	c, l
	ld	b, h
	pop	hl
	; hl will be ptr to new end of string
	ld	a, (ix-8)
	add	a, l
	jr	nc, +_
	inc	h
_:	ld	l, a
	ex	de, hl
	; Make room
	bit	insertStrSub, (iy+editorFlags)
	jr	nz, +_
	inc	bc
_:	ld	a, b
	or	c
	jr	z, instrb ; Attempting to move 0 bytes will move 64K bytes.  Very bad.
	lddr
instrb:	; Insert
	ld	l, (ix-6)
	ld	h, (ix-5) ; src
	ld	e, (ix-2)
	ld	d, (ix-1) ; dest
	ld	c, (hl)
	inc	hl
	ld	b, 0
	ldir
	ld	sp, ix
	pop	ix
	ret


;------ ------------------------------------------------------------------------
insertByte:
; Inputs:
;  - A: Byte
;  - HL: Location to insert into
	push	hl
	push	de
	push	bc
	push	hl
	push	af
	ld	de, argBuf
	ld	a, 2
	ld	(de), a
	inc	de
	pop	af
	push	af
	srl	a
	srl	a
	srl	a
	srl	a
	call	+_
	pop	af
	and	00001111b
	call	+_
	pop	bc
	ld	de, instrTextBuf
	ld	hl, argBuf
	call	InsertString
	pop	bc
	pop	de
	pop	hl
	ret
_:	ld	b, '0'
	cp	0Ah
	jr	c, +_
	ld	b, 'A'-0Ah
_:	add	a, b
	ld	(de), a
	inc	de
	ret
