; This program is free software. It comes without any warranty, to
; the extent permitted by applicable law. You can redistribute it
; and/or modify it under the terms of the Do What The Fuck You Want
; To Public License, Version 2, as published by Sam Hocevar. See
; http://sam.zoy.org/wtfpl/COPYING for more details.

;           1111111111222222222233
; 012345678901234==789012345678901
;         LCD Port Monitor
; Port: xx
; Value: xx
;lcdPortMonPortLoc	.equ	6*256+1
;lcdPortMonValLoc	.equ	7*256+2

lcdPortMonGoto:
	ld	hl, portMonPortLoc
	call	Locate
	call	GetHexByte
	ld	(lcdPortMonPort), a
	jr	lcdPortMonLoop2

lcdPortMonWrite:
	ld	hl, portMonValLoc
	call	Locate
	call	GetHexByte
	push	af
	call	GetHexByte
	pop	de
	ld	e, a
	ld	a, (lcdPortMonPort)
	di
	out	(pLcdCmd), a
	out	(pLcdCmd), a
	ld	c, pLcdData
	out	(c), d
	out	(c), e
	ei
	jr	lcdPortMonKeyLoop
	
LcdPortMonitor:
	call	SetFullScrnWind
	call	HomeUp
	ld	hl, lcdPortMonString
	call	PutSClrWind
lcdPortMonLoop2:
	ld	hl, portMonPortLoc
	call	Locate
	ld	a, (lcdPortMonPort)
	call	DispByte
lcdPortMonKeyLoop:
	ld	hl, portMonValLoc
	call	Locate
	ld	a, (lcdPortMonPort)
	di
	out	(pLcdCmd), a
	out	(pLcdCmd), a
	ld	c, pLcdData
	in	a, (c)
	in	b, (c)
	ei
	call	DispByte
	ld	a, b
	call	DispByte
	call	GetCSC
	ld	hl, lcdPortMonKeyTable
	call	ProcessKeyJumpTable
	jr	lcdPortMonKeyLoop

lcdPortMonLeft:
	ld	a, (lcdPortMonPort)
	dec	a
	ld	(lcdPortMonPort), a
	jr	lcdPortMonLoop2
lcdPortMonRight:
	ld	a, (lcdPortMonPort)
	inc	a
	ld	(lcdPortMonPort), a
	jr	lcdPortMonLoop2
lcdPortMonFastLeft:
	ld	a, (lcdPortMonPort)
	sub	16
	ld	(lcdPortMonPort), a
	jr	lcdPortMonLoop2
lcdPortMonFastRight:
	ld	a, (lcdPortMonPort)
	add	a, 16
	ld	(lcdPortMonPort), a
	jr	lcdPortMonLoop2