; This program is free software. It comes without any warranty, to
; the extent permitted by applicable law. You can redistribute it
; and/or modify it under the terms of the Do What The Fuck You Want
; To Public License, Version 2, as published by Sam Hocevar. See
; http://sam.zoy.org/wtfpl/COPYING for more details.

;           1111111111222222222233
; 012345678901234==789012345678901
;           Port Monitor
; Port: xx
; Value: xx
portMonPortLoc	.equ	6*256+1
portMonValLoc	.equ	7*256+2

portMonGoto:
	ld	hl, portMonPortLoc
	call	Locate
	call	GetHexByte
	cp	10h
	jr	c, +_
	cp	15h
	jr	c, portMonLoop2
_:	ld	(portMonPort), a
	jr	portMonLoop2

portMonWrite:
	ld	hl, portMonValLoc
	call	Locate
	call	GetHexByte
	ld	b, a
	ld	a, (portMonPort)
	ld	c, a
	out	(c), b
	jr	portMonKeyLoop
	
PortMonitor:
	ld	a, (portMonPort)
	cp	10h
	jr	c, +_
	cp	15h
	jr	nc, +_
	xor	a
_:	ld	(portMonPort), a
	call	SetFullScrnWind
	call	HomeUp
	ld	hl, portMonString
	call	PutSClrWind
portMonLoop2:
	ld	hl, portMonPortLoc
	call	Locate
	ld	a, (portMonPort)
	call	DispByte
portMonKeyLoop:
	ld	hl, portMonValLoc
	call	Locate
	ld	a, (portMonPort)
	ld	c, a
	in	a, (c)
	call	DispByte
	call	GetCSC
	ld	hl, portMonKeyTable
	call	ProcessKeyJumpTable
	jr	portMonKeyLoop

portMonLeft:
	ld	a, (portMonPort)
	dec	a
	cp	13h
	jr	nz, +_
	ld	a, 0Fh
_:	ld	(portMonPort), a
	jr	portMonLoop2
portMonRight:
	ld	a, (portMonPort)
	inc	a
	cp	10h
	jr	nz, +_
	ld	a, 14h
_:	ld	(portMonPort), a
	jr	portMonLoop2
portMonFastLeft:
	ld	a, (portMonPort)
	sub	16
	cp	10h
	jr	c, +_
	cp	15h
	jr	nc, +_
	ld	a, 0Fh
_:	ld	(portMonPort), a
	jr	portMonLoop2
portMonFastRight:
	ld	a, (portMonPort)
	add	a, 16
	cp	10h
	jr	c, +_
	cp	15h
	jr	nc, +_
	ld	a, 14h
_:	ld	(portMonPort), a
	jr	portMonLoop2